## davix 0.6.3

=== CMakeLists.txt ===

## cmake build script for davix
project (davix)
cmake_minimum_required (VERSION 2.6)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
option(SHARED_LIBRARY "generate shared library" TRUE)
option(STATIC_LIBRARY  "generate static library" FALSE)


# build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif(NOT CMAKE_BUILD_TYPE)

# load module
include(DefineInstallationPaths REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(PortabilityGNUCheck REQUIRED)
include(CMakeCXX11Support REQUIRED)

#enable testing
INCLUDE(CTest)


set(OUTPUT_NAME_DAVIX "davix")
set(VERSION_MAJOR 0)
set(VERSION_MINOR 6)
set(VERSION_PATCH 3)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
set(VERSION_TAG "")


# dependency mode
option(BOOST_EXTERNAL "Enable the usage of an external boost dependency" TRUE)
set (Boost_NO_BOOST_CMAKE ON)

# components
option(ENABLE_TOOLS "enable or disable tools " TRUE)
option(ENABLE_HTML_DOCS "enable or disable generation of HTML documentation" FALSE)

# features
option(ENABLE_IPV6 "enable or disable IPv6 support " TRUE)
option(ENABLE_TCP_NODELAY "enable or disable tcp_nodelay" TRUE)
option(ENABLE_THIRD_PARTY_COPY "enable or disable third party copy support" FALSE)

# tests
option(UNIT_TESTS "enable or disable the unit tests" FALSE)
option(FUNCTIONAL_TESTS "enable or disable the functional tests" FALSE)
option(BENCH_TESTS "enable or disable the bench tests" FALSE)

# disable clock_gettime if building a static library
if(STATIC_LIBRARY)
    set(HAVE_CLOCK_GETTIME FALSE)
endif()

# libs checks
find_package(Threads)

# openssl
find_package(OpenSSL)
SET(LIBSSL_PKG_LIBRARIES "${OPENSSL_LIBRARIES}")
SET(CRYPTO_PKG "")
SET(LIBSSL_PKG_INCLUDE_DIRS "${OPENSSL_INCLUDE_DIR}")

find_package(LibXml2)
set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})

if(BOOST_EXTERNAL)
find_package(Boost 1.41.0 COMPONENTS thread system program_options)
endif(BOOST_EXTERNAL)

#const
set(HAVE_OPENSSL 1)
set(NE_HAVE_SSL 1)

add_subdirectory(deps)




## general defs
add_definitions( -D_GNU_SOURCE)              # GNU source, import LFS, etc...
add_definitions( -D__DAVIX_INSIDE__)         # protection flag
add_definitions( -D__STDC_LIMIT_MACROS )     # C99 limit macros


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

include_directories( ${Boost_INCLUDE_DIRS})
include_directories( ${HTTPLIB_PKG_INCLUDE_DIRS} ${GLIB2_PKG_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/deps ${CMAKE_CURRENT_SOURCE_DIR}/deps/libneon/src/ )
include_directories( ${CMAKE_SOURCE_DIR}/include/davix )
include_directories( ${CMAKE_SOURCE_DIR}/src/libs/)

add_subdirectory (src)
add_subdirectory (doc)
add_subdirectory (dist)
add_subdirectory (test)
add_subdirectory (packaging)


#############################################################################
## headers

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/davix/
                DESTINATION ${INCLUDE_INSTALL_DIR}/davix)

##############################################################################
## Doc file
install(FILES RELEASE-NOTES LICENSE
                DESTINATION ${DOC_INSTALL_DIR}/) # install release notes


#######################################################
# Configure an 'uninstall' target
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/tools/CMakeLists.txt ===
# main file for command line tools
#




LIST(APPEND davix_main_src "davix_tool_main.cpp")
LIST(APPEND davix_ls_main_src "davix_tool_ls_main.cpp")
LIST(APPEND davix_get_main_src "davix_tool_get_main.cpp")
LIST(APPEND davix_put_main_src "davix_tool_put_main.cpp")
LIST(APPEND davix_rm_main_src "davix_tool_rm_main.cpp")
LIST(APPEND davix_mkcol_main_src "davix_tool_mkcol_main.cpp")
LIST(APPEND davix_mv_main_src "davix_tool_mv_main.cpp")
LIST(APPEND davix_copy_main_src "davix_tool_copy_main.cpp")
LIST(APPEND davix_tool_common_src "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_params.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_util.cpp" "${SRC_SIMPLE_GET_PASS}" "${CMAKE_CURRENT_SOURCE_DIR}/davix_op.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_taskqueue.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread_pool.cpp")
SET(davix_tool_common_src_up "${davix_tool_common_src}" PARENT_SCOPE)

link_directories(${PROJECT_BINARY_DIR}/src/)


add_definitions(-DNO_BOOST_INCLUDE)

## rt link
set(RT_LIBRARIES "")
if(HAVE_CLOCK_GETTIME)
    set(RT_LIBRARIES "rt")
endif(HAVE_CLOCK_GETTIME)


## davix tool lib
add_library(davix_tool_lib STATIC ${davix_tool_common_src})


## davix cmd line
add_executable(davix_tool ${davix_main_src})

target_link_libraries(davix_tool davix_tool_lib libdavix ${RT_LIBRARIES})
set_target_properties(davix_tool PROPERTIES
                                OUTPUT_NAME "davix-http")

## davix ls cmd line
add_executable(davix_ls_tool ${davix_ls_main_src})

target_link_libraries(davix_ls_tool davix_tool_lib libdavix ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
set_target_properties(davix_ls_tool PROPERTIES
                                OUTPUT_NAME "davix-ls")


## davix get cmd line
add_executable(davix_get_tool ${davix_get_main_src})

target_link_libraries(davix_get_tool davix_tool_lib libdavix pthread ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
set_target_properties(davix_get_tool PROPERTIES
                                OUTPUT_NAME "davix-get")

## davix put cmd line
add_executable(davix_put_tool ${davix_put_main_src})

target_link_libraries(davix_put_tool davix_tool_lib libdavix pthread ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
set_target_properties(davix_put_tool PROPERTIES
                                OUTPUT_NAME "davix-put")


## davix del cmd line
add_executable(davix_mkdir_tool ${davix_mkcol_main_src})

target_link_libraries(davix_mkdir_tool davix_tool_lib libdavix ${RT_LIBRARIES})
set_target_properties(davix_mkdir_tool PROPERTIES
                                OUTPUT_NAME "davix-mkdir")

## davix rm cmd line
add_executable(davix_rm_tool ${davix_rm_main_src})

target_link_libraries(davix_rm_tool davix_tool_lib libdavix ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
set_target_properties(davix_rm_tool PROPERTIES
                                OUTPUT_NAME "davix-rm")

## davix mv cmd line
add_executable(davix_mv_tool ${davix_mv_main_src})

target_link_libraries(davix_mv_tool davix_tool_lib libdavix ${RT_LIBRARIES})
set_target_properties(davix_mv_tool PROPERTIES
                                OUTPUT_NAME "davix-mv")



install(TARGETS davix_tool davix_ls_tool davix_get_tool davix_put_tool davix_mkdir_tool davix_rm_tool davix_mv_tool
         DESTINATION ${BIN_INSTALL_DIR}/)

## davix cp cmd line
if (ENABLE_THIRD_PARTY_COPY)

    add_executable(davix_cp_tool ${davix_copy_main_src})

    target_link_libraries(davix_cp_tool davix_copy davix_tool_lib ${RT_LIBRARIES})
    set_target_properties(davix_cp_tool PROPERTIES
                                OUTPUT_NAME "davix-cp")
    add_dependencies(davix_cp_tool davix_copy)

    install(TARGETS davix_cp_tool
            DESTINATION ${BIN_INSTALL_DIR}/)

endif (ENABLE_THIRD_PARTY_COPY)

=== test/functional/CMakeLists.txt ===
# main file for src


if(FUNCTIONAL_TESTS)

set(src_davix_test_lib "davix_test_lib.cpp")

#set( src_test_req "test_request.cpp")
#set( src_test_checksum "test_checksum.cpp")
#set( src_test_stat_session "test_stat_session.cpp")
#set( src_test_rw "davix_rw_test.cpp")
#set( src_test_opendir "test_opendir.cpp")
#set( src_test_opendir_partial "test_opendir_partial.cpp")
#set( src_test_opendirpp "test_opendirpp.cpp")
#set( src_test_directory "test_directory.cpp")
#set( src_test_auto_stat_mkdir_check "test_auto_stat_mkdir_check.cpp")
#set( src_test_auto_rmdir_unlink_delete "test_auto_rmdir_unlink_delete.cpp")
#set( src_test_valid_read_generic_simple "test_valid_read_generic_simple.cpp")
#set( src_test_valid_write_read_generic_simple "test_valid_write_read_generic_simple.cpp")
#set( src_test_valid_write_read_fd "test_valid_write_read_fd.cpp")
#set( src_test_valid_write_read_vector_simple "test_valid_write_read_vector_simple.cpp")
#set( src_tool_read_vector_simple "tool_read_vector_simple.cpp")
#set( src_tool_get_replicas "tool_get_replica_simple.cpp")
#set( src_test_mv "test_mv.cpp")

set( src_tester "tester.cpp")


add_library(test_davix_functional_lib STATIC ${src_davix_test_lib})

#add_executable(test_request ${src_test_req} )
#target_link_libraries(test_request libdavix  test_davix_functional_lib)

#add_executable(tool_read_vector_simple ${src_tool_read_vector_simple} )
#target_link_libraries(tool_read_vector_simple libdavix test_davix_functional_lib )

#add_executable(test_rw_fd ${src_test_valid_write_read_fd})
#target_link_libraries(test_rw_fd libdavix test_davix_functional_lib )

#add_executable(test_stat_auto_check ${src_test_auto_stat_mkdir_check})
#target_link_libraries(test_stat_auto_check libdavix test_davix_functional_lib)

#add_executable(test_checksum ${src_test_checksum})
#target_link_libraries(test_checksum libdavix test_davix_functional_lib)

#add_executable(test_auto_rmdir_unlink_delete ${src_test_auto_rmdir_unlink_delete})
#target_link_libraries(test_auto_rmdir_unlink_delete libdavix test_davix_functional_lib)

#add_executable(test_stat_session ${src_test_stat_session})
#target_link_libraries(test_stat_session libdavix test_davix_functional_lib)


#add_executable(test_rw ${src_test_rw})
#target_link_libraries(test_rw libdavix test_davix_functional_lib)

#add_executable(test_opendir ${src_test_opendir} )
#target_link_libraries(test_opendir libdavix test_davix_functional_lib)


#add_executable(test_directory ${src_test_directory} )
#target_link_libraries(test_directory libdavix test_davix_functional_lib)

#add_executable(test_opendir_partial ${src_test_opendir_partial})
#target_link_libraries(test_opendir_partial libdavix test_davix_functional_lib)

#add_executable(test_opendirpp ${src_test_opendirpp})
#target_link_libraries(test_opendirpp libdavix test_davix_functional_lib)

#add_executable(test_valid_read_generic_simple ${src_test_valid_read_generic_simple})
#target_link_libraries(test_valid_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_generic_simple ${src_test_valid_write_read_generic_simple})
#target_link_libraries(test_valid_write_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_vector_simple ${src_test_valid_write_read_vector_simple})
#target_link_libraries(test_valid_write_read_vector_simple libdavix test_davix_functional_lib)


#add_executable(tool_get_replicas ${src_tool_get_replicas})
#target_link_libraries(tool_get_replicas libdavix test_davix_functional_lib)

#add_executable(test_mv ${src_test_mv})
#target_link_libraries(test_mv libdavix test_davix_functional_lib)

add_executable(tester ${src_tester})
target_link_libraries(tester libdavix ${Boost_LIBRARIES} test_davix_functional_lib)

function(assert_not_empty var)
    if("${var}" STREQUAL "")
        message(FATAL_ERROR "variable must not be empty")
    endif()
endfunction(assert_not_empty)

function(matchparam param input)
    set(normalchars "a-zA-Z0-9/:.,")
    string(REGEX MATCH "${param} +(([${normalchars}]-| |[${normalchars}])+)" tmp ${input})
    if(NOT "${tmp}" STREQUAL "")
        string(REPLACE " " "" stripped ${CMAKE_MATCH_1})
        set(match ${stripped} PARENT_SCOPE)
    else()
        set(match "" PARENT_SCOPE)
    endif()
endfunction(matchparam)

function(paramexists param input)
    string(REGEX MATCH "${param}" tmp ${input})
    set(match ${tmp} PARENT_SCOPE)
endfunction(paramexists)

function(runtest params)
    matchparam("--auth" ${params})
    set(auth ${match})
    assert_not_empty(${auth})

    matchparam("--command" ${params})
    set(command ${match})
    assert_not_empty(${command})

    matchparam("--uri" ${params})
    set(uri ${match})
    assert_not_empty(${uri})

    matchparam("--s3region" ${params})
    set(s3region ${match})

    paramexists("--s3alternate" ${params})
    set(s3alternate ${match})

    # build testname
    set(testname "${auth}")

    if(NOT "${s3region}" STREQUAL "")
        set(testname "${testname}|v4")
    endif()

    if(NOT "${s3alternate}" STREQUAL "")
        set(testname "${testname}|alt")
    endif()

    set(testname "${testname}|${command}|${uri}")

    set(arguments ${params})
    separate_arguments(arguments)
    add_test(${testname} tester ${arguments})
endfunction(runtest)

function(preadvectest_single params ranges)
    runtest("${params} --command preadvec ${ranges}")
    runtest("${params} --command preadvec ${ranges} nomulti")
endfunction(preadvectest_single)

function(preadvectest params)
    preadvectest_single("${params}" "0-10,5-10,3-4,30-40,200-305,1000-1500")
    preadvectest_single("${params}" "0-10,5-10")
    preadvectest_single("${params}" "0-10,15-20")
endfunction(preadvectest)

function(fulltest params)
    runtest("${params} --command makeCollection")
    runtest("${params} --command populate 5")
    runtest("${params} --command listing 5")
    preadvectest("${params}")
    runtest("${params} --command movefile")
    runtest("${params} --command depopulate 3")
    runtest("${params} --command countfiles 2")
    runtest("${params} --command remove")
endfunction(fulltest)

function(s3tests params)
    runtest("${params} --command makeCollection")
    runtest("${params} --command populate 5")
    runtest("${params} --command listing 5")
    preadvectest("${params}")
    runtest("${params} --command movefile")
    runtest("${params} --command depopulate 3")
    runtest("${params} --command countfiles 2")
    runtest("${params} --command depopulate 5")
endfunction(s3tests)

function(test_with_proxy uri)
    fulltest("--auth proxy --uri ${uri}")
endfunction(test_with_proxy)

function(test_s3 accesskey secretkey uri region use_alt)
    set(params "--auth aws --s3accesskey ${accesskey} --s3secretkey ${secretkey} --uri ${uri}")
    if(NOT "${region}" STREQUAL "")
        set(params "${params} --s3region ${region}")
    endif()

    if(use_alt MATCHES "^alt$")
        set(params "${params} --s3alternate")
    elseif(NOT use_alt MATCHES "^noalt$")
        message(FATAL_ERROR "Invalid option passed to test_s3 for use_alt: ${use_alt}")
    endif()

    s3tests(${params})
endfunction(test_s3)

function(test_azure azurekey uri)
    set(params "--auth azure --azurekey ${azurekey} --uri ${uri}")

    runtest("${params} --command populate 5")
    runtest("${params} --command statdir")
    runtest("${params} --command listing 5")
    preadvectest("${params}")
    runtest("${params} --command depopulate 5")
endfunction(test_azure)


include(${CMAKE_SOURCE_DIR}/credentials/creds.cmake)


### DEPRECATED, to remove soon

function(test_dav_endpoint_ronly name cred)

    add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
    add_test(test_opendir_${name} test_opendir ${name} ${cred})
  #  add_test(test_opendir_c_${name} test_opendir_c ${name} ${cred})
    add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
  #  add_test(test_stat_c_${name} test_stat_c ${name} ${cred})
endfunction(test_dav_endpoint_ronly name cred)

function(test_dav_endpoint_rw name cred)

    add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
    add_test(test_opendir_${name} test_opendir ${name} ${cred})
    add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
    add_test(test_stat_auto_check_${name} test_stat_auto_check ${name} ${cred})
endfunction(test_dav_endpoint_rw name cred)

function(listdir_partial name size cred)
    add_test(test_opendir_partial_${name}  test_opendir_partial ${name} ${size} ${cred})
endfunction(listdir_partial name size cred)


function(test_collection name cred)
    add_test(test_directory_${name} test_directory ${name} ${cred})
endfunction(test_collection name cred)

function(test_valid_read_generic url cred)
    add_test(test_valid_read_generic_${url} test_valid_read_generic_simple ${url} ${cred})
endfunction(test_valid_read_generic url cred)

function(test_valid_delete_all url cred)
    add_test(test_auto_rmdir_unlink_delete_${url} test_auto_rmdir_unlink_delete ${url} ${cred})
endfunction(test_valid_delete_all url cred)


function(test_valid_write_read_generic url cred)
    add_test(test_valid_write_read_generic_simple_${url} test_valid_write_read_generic_simple ${url} ${cred})
    add_test(test_rw_fd_${url} test_rw_fd ${url} ${cred})
    add_test(test_valid_write_read_vector_simple_${url} test_valid_write_read_vector_simple ${url} ${cred})
endfunction(test_valid_write_read_generic url cred)

function(test_replica_listing_existing url cred)
   add_test(tool_get_replicas_${url} tool_get_replicas ${url} ${cred})
endfunction(test_replica_listing_existing url cred)

function(test_rename url cred)
    add_test(test_mv_${url} test_mv ${url} ${cred})
endfunction(test_rename url cred)

# include(ctest_functional.cmake)

endif(FUNCTIONAL_TESTS)

=== test/unit/CMakeLists.txt ===
# main file for src

if(UNIT_TESTS)

include_directories(${PROJECT_SOURCE_DIR}/src "." ${GTEST_INCLUDE_DIRS})
include_directories(${HEADER_RAPIDJSON})

## gtest
set(GTEST ${CMAKE_SOURCE_DIR}/deps/googletest/googletest )
set(GTEST_BINARY_DIR ${CMAKE_BINARY_DIR}/deps/googletest/googletest )

include_directories(${GTEST}/include)
add_subdirectory(${GTEST} ${GTEST_BINARY_DIR} )

## alibxx

file(GLOB src_alibxx alibxx/*.cpp)
file(GLOB src_neon neon/*.cpp)
file(GLOB src_datetime datetime/*.cpp)
file(GLOB src_credential credential/*.cpp)
file(GLOB src_context context/*.cpp)
file(GLOB src_session session/*.cpp)
file(GLOB src_parser xmlparser/*.cpp)
file(GLOB src_files files/*.cpp)
file(GLOB src_auth  auth/*.cpp)
LIST(APPEND src_utils utils/utils_test.cpp ${SRC_STRING_UTILS_CPP})
LIST(APPEND src_parser parser/parser_test.cpp)
LIST(APPEND src_httprequest sessionfactory/test_factory.cpp)


add_definitions( -DTEST_VALID_CERT="${TEST_CRED_PATH}" -DTEST_VALID_CERT_PASS="${TEST_CRED_PASS}")
add_executable(g_test_unit_davix_exe ${src_context} ${src_session} ${src_credential}
                ${src_httprequest} ${src_datetime} ${src_neon} ${src_parser} ${src_auth} ${src_utils} ${src_parser} ${SRC_BASE64}
                ${SRC_HMACSHA1} ${davix_tool_common_src} ${src_files} ${src_alibxx})

target_link_libraries(g_test_unit_davix_exe alibxx_core libdavix gtest gtest_main ${CMAKE_THREAD_LIBS_INIT} ${LIBSSL_PKG_LIBRARIES} ${Boost_LIBRARIES})

if(HAVE_CLOCK_GETTIME)
    target_link_libraries(g_test_unit_davix_exe rt)
endif(HAVE_CLOCK_GETTIME)

add_dependencies(g_test_unit_davix_exe libdavix)



add_test(g_test_unit_davix g_test_unit_davix_exe )

endif(UNIT_TESTS)

=== debian/changelog ===
davix (0.6.3-1build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:15:51 +0000

davix (0.6.3-1) unstable; urgency=medium

  * Update to version 0.6.3

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Tue, 19 Apr 2016 15:40:50 +0200

davix (0.6.0-1) unstable; urgency=medium

  * Update to version 0.6.0

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 04 Mar 2016 17:59:56 +0100

=== debian/control ===
Source: davix
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libboost-system-dev, libboost-thread-dev, libboost-program-options-dev, rapidjson-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python-sphinx
Standards-Version: 3.9.8
Section: net
Homepage: http://dmc.web.cern.ch/projects/davix/home

Package: davix
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0v5 (= ${binary:Version})
Description: Toolkit for http based file management
 Davix is a toolkit designed for file operations with http based protocols
 (WebDav, Amazon S3, ...).

Package: libdavix0v5
Section: libs
Architecture: any
Multi-Arch: same
Replaces: libdavix0 (<< 0.4.1-2~)
Breaks: libdavix0 (<< 0.4.1-2~)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Runtime library for davix
 Library for davix. Davix is a toolkit designed for file operations with
 http based protocols (WebDav, Amazon S3, ...).

Package: davix-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libdavix0v5 (= ${binary:Version})
Description: Development files for davix
 Development files for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: davix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Documentation for davix
 Documentation and examples for davix. Davix is a toolkit designed for file
 operations with Http based protocols (WebDav, Amazon S3, ...).

Package: davix-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, davix (= ${binary:Version})
Description: Debug symbols for the davix tools
 Debug symbols for the davix tools. Davix is a toolkit designed for
 file operations with http based protocols (WebDav, Amazon S3, ...).

Package: libdavix-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libdavix0v5 (= ${binary:Version})
Description: Debug symbols for the davix library
 Debug symbols for the davix library. Davix is a toolkit designed for
 file operations with http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	# Remove bundled stuff
	rm -rf deps/boost_intern
	rm -rf deps/rapidjson
	rm -rf deps/strptime
	rm -rf test/pywebdav
	# Debian's gtest is not precompiled - link source
	ln -fs /usr/src/gtest deps/googletest/googletest
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DUNIT_TESTS=TRUE \
		-DGTEST_EXTERNAL=TRUE \
		-DENABLE_HTML_DOCS=TRUE \
		-DENABLE_THIRD_PARTY_COPY=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	rm debian/tmp/usr/share/doc/davix/LICENSE
	dh_install --fail-missing

override_dh_strip:
	dh_strip -X/lib/ --dbg-package davix-dbg
	dh_strip -X/bin/ --dbg-package libdavix-dbg

override_dh_auto_clean:
	rm -f deps/googletest/googletest
	dh_auto_clean

override_dh_auto_test:
	( cd obj-* ; make abi-check )
	dh_auto_test -- ARGS+="-V -T Test"

## davix 0.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 set(OUTPUT_NAME_DAVIX "davix")
 set(VERSION_MAJOR 0)
 set(VERSION_MINOR 6)
-set(VERSION_PATCH 3)
+set(VERSION_PATCH 4)
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 set(VERSION_TAG "")
 
@@ -52,11 +52,6 @@
 option(FUNCTIONAL_TESTS "enable or disable the functional tests" FALSE)
 option(BENCH_TESTS "enable or disable the bench tests" FALSE)
 
-# disable clock_gettime if building a static library
-if(STATIC_LIBRARY)
-    set(HAVE_CLOCK_GETTIME FALSE)
-endif()
-
 # libs checks
 find_package(Threads)
 
@@ -70,7 +65,7 @@
 set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})
 
 if(BOOST_EXTERNAL)
-find_package(Boost 1.41.0 COMPONENTS thread system program_options)
+find_package(Boost 1.41.0 COMPONENTS thread system)
 endif(BOOST_EXTERNAL)
 
 #const
@@ -104,9 +99,13 @@
 
 #############################################################################
 ## headers
+configure_file("${CMAKE_SOURCE_DIR}/include/davix/features.hpp.in"
+               "${CMAKE_SOURCE_DIR}/include/davix/features.hpp"
+               @ONLY)
 
 install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/davix/
-                DESTINATION ${INCLUDE_INSTALL_DIR}/davix)
+        DESTINATION ${INCLUDE_INSTALL_DIR}/davix
+        PATTERN "*.in" EXCLUDE)
 
 ##############################################################################
 ## Doc file
@@ -123,4 +122,3 @@
 
 ADD_CUSTOM_TARGET(uninstall
   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
-

=== deps/CMakeLists.txt ===
###
## compile dependencies of davix


IF(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "${CMAKE_CURRENT_SOURCE_DIR}/strptime/strptime.c" PARENT_SCOPE)
ELSE(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "" PARENT_SCOPE)
ENDIF(NOT HAVE_STRPTIME_H)


SET(SRC_SIMPLE_GET_PASS "${CMAKE_CURRENT_SOURCE_DIR}/simple_getpass/simple_get_pass.cpp" PARENT_SCOPE)
SET(SRC_STRING_UTILS_CPP "${CMAKE_CURRENT_SOURCE_DIR}/string_utils/stringutils.cpp" PARENT_SCOPE)


## boost
if(NOT Boost_FOUND)
SET(Boost_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/boost_intern" PARENT_SCOPE)

add_subdirectory(boost_intern/src)
set(Boost_LIBRARIES boost_static_internal PARENT_SCOPE)
endif(NOT Boost_FOUND)

add_subdirectory(libneon)


if(NOT HAVE_SYSSOCKET_H)
set(SOCKET_PKG_LIBRARIES "ws2_32")
endif(NOT HAVE_SYSSOCKET_H)

SET(HTTPLIB_PKG_VERSION "0.29.0" PARENT_SCOPE)
SET(HTTPLIB_PKG_STATIC_LIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/libneon/src/libneon.a")
SET(HTTPLIB_PKG_LIBRARIES ${HTTPLIB_PKG_STATIC_LIB_PATH} ${LIBSSL_PKG_LIBRARIES} ${LIBGSSAPI_PKG_LIBRARIES} ${LIBXML2_LIBRARIES} ${SOCKET_PKG_LIBRARIES} PARENT_SCOPE)
SET(HTTPLIB_PKG_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/libneon/src/  ${LIBXML2_INCLUDE_DIRS} ${LIBSSL_PKG_INCLUDE_DIRS}  ${LIBGSSAPI_PKG_INCLUDE_DIRS} PARENT_SCOPE)

=== src/CMakeLists.txt ===
# main file for src

FILE(GLOB src_davix
    "*.cpp" "neon/*.cpp" "status/*.cpp" "fileops/*.cpp"
    "params/*.cpp" "auth/*.cpp" "file/*.cpp" "deprecated/*.cpp"
    "request/*.cpp" "hooks/*.cpp" "modules/*.cpp" "utils/*.cpp" "xml/*.cpp"
)


include_directories("libs" ".")

configure_file(davix_internal_config.in ${CMAKE_CURRENT_BINARY_DIR}/davix_internal_config.hpp @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
link_directories(${HTTPLIB_PKG_LIBRARY_DIR} ${CRYPTO_PKG_LIBRARY_DIR}
                                        ${LIBXML2_PKG_LIBRARY_DIR} )

add_subdirectory(modules/copy)
add_subdirectory(libs)

if(ENABLE_TOOLS)
  add_subdirectory(tools)
endif()

LIST(APPEND SRC_DAVIX_FULL ${src_davix} ${src_datetime}
                           ${SRC_STRPTIME} ${SRC_MEMPCPY} ${SRC_STRLCPY} ${SRC_STRING_UTILS_CPP}
                           ${SRC_BASE64} ${SRC_HMACSHA1})


add_definitions(${HTTPLIB_PKG_CFLAGS} )

if(SHARED_LIBRARY)
add_library(libdavix  SHARED ${SRC_DAVIX_FULL} )
add_dependencies(libdavix neon)


target_link_libraries(libdavix  alibxx_core ${HTTPLIB_PKG_LIBRARIES} ${CRYPTO_PKG_LIBRARIES}
                                ${CMAKE_THREAD_LIBS_INIT} ${SOCKET_PKG_LIBRARIES} ${Boost_LIBRARIES})

set_target_properties(libdavix PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})

install(TARGETS libdavix
             DESTINATION ${LIB_INSTALL_DIR} )

add_PkgConfigFile_for_Library("davix.pc" libdavix
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Libdavix, IO library for HTTP based protocols"
                               )
#install pkgconfig
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix.pc
        DESTINATION ${PKGCONFIG_FILES_DIR} )

endif(SHARED_LIBRARY)



if(STATIC_LIBRARY)

add_definitions(-DA_LIB_NAMESPACE=Davix)
FILE(GLOB src_alibxx_static "libs/alibxx/*/*.cpp")
add_library(libdavix_static  STATIC ${SRC_DAVIX_FULL} ${src_alibxx_static})

set_target_properties(libdavix_static PROPERTIES
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})


install(TARGETS libdavix_static
             DESTINATION ${LIB_INSTALL_DIR} )

endif(STATIC_LIBRARY)

SET(davix_tool_common_src "${davix_tool_common_src_up}" PARENT_SCOPE)

=== src/tools/CMakeLists.txt ===
# main file for command line tools
#




LIST(APPEND davix_main_src "davix_tool_main.cpp")
LIST(APPEND davix_ls_main_src "davix_tool_ls_main.cpp")
LIST(APPEND davix_get_main_src "davix_tool_get_main.cpp")
LIST(APPEND davix_put_main_src "davix_tool_put_main.cpp")
LIST(APPEND davix_rm_main_src "davix_tool_rm_main.cpp")
LIST(APPEND davix_mkcol_main_src "davix_tool_mkcol_main.cpp")
LIST(APPEND davix_mv_main_src "davix_tool_mv_main.cpp")
LIST(APPEND davix_copy_main_src "davix_tool_copy_main.cpp")
LIST(APPEND davix_tool_common_src "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_params.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_util.cpp"
                                  "${SRC_SIMPLE_GET_PASS}"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_op.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_taskqueue.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread_pool.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_config_parser.cpp")
SET(davix_tool_common_src_up "${davix_tool_common_src}" PARENT_SCOPE)

link_directories(${PROJECT_BINARY_DIR}/src/)


add_definitions(-DNO_BOOST_INCLUDE)

## davix tool lib
add_library(davix_tool_lib STATIC ${davix_tool_common_src})


## davix cmd line
add_executable(davix_tool ${davix_main_src})

target_link_libraries(davix_tool davix_tool_lib libdavix)
set_target_properties(davix_tool PROPERTIES
                                OUTPUT_NAME "davix-http")

## davix ls cmd line
add_executable(davix_ls_tool ${davix_ls_main_src})

target_link_libraries(davix_ls_tool davix_tool_lib libdavix ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_ls_tool PROPERTIES
                                OUTPUT_NAME "davix-ls")


## davix get cmd line
add_executable(davix_get_tool ${davix_get_main_src})

target_link_libraries(davix_get_tool davix_tool_lib libdavix pthread ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_get_tool PROPERTIES
                                OUTPUT_NAME "davix-get")

## davix put cmd line
add_executable(davix_put_tool ${davix_put_main_src})

target_link_libraries(davix_put_tool davix_tool_lib libdavix pthread ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_put_tool PROPERTIES
                                OUTPUT_NAME "davix-put")


## davix del cmd line
add_executable(davix_mkdir_tool ${davix_mkcol_main_src})

target_link_libraries(davix_mkdir_tool davix_tool_lib libdavix)
set_target_properties(davix_mkdir_tool PROPERTIES
                                OUTPUT_NAME "davix-mkdir")

## davix rm cmd line
add_executable(davix_rm_tool ${davix_rm_main_src})

target_link_libraries(davix_rm_tool davix_tool_lib libdavix ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_rm_tool PROPERTIES
                                OUTPUT_NAME "davix-rm")

## davix mv cmd line
add_executable(davix_mv_tool ${davix_mv_main_src})

target_link_libraries(davix_mv_tool davix_tool_lib libdavix)
set_target_properties(davix_mv_tool PROPERTIES
                                OUTPUT_NAME "davix-mv")



install(TARGETS davix_tool davix_ls_tool davix_get_tool davix_put_tool davix_mkdir_tool davix_rm_tool davix_mv_tool
         DESTINATION ${BIN_INSTALL_DIR}/)

## davix cp cmd line
if (ENABLE_THIRD_PARTY_COPY)

    add_executable(davix_cp_tool ${davix_copy_main_src})

    target_link_libraries(davix_cp_tool davix_copy davix_tool_lib)
    set_target_properties(davix_cp_tool PROPERTIES
                                OUTPUT_NAME "davix-cp")
    add_dependencies(davix_cp_tool davix_copy)

    install(TARGETS davix_cp_tool
            DESTINATION ${BIN_INSTALL_DIR}/)

endif (ENABLE_THIRD_PARTY_COPY)

=== test/functional/CMakeLists.txt ===
--- 
+++ 
@@ -107,15 +107,11 @@
     set(match ${tmp} PARENT_SCOPE)
 endfunction(paramexists)
 
-function(runtest params)
+function(runtest params cmd)
     matchparam("--auth" ${params})
     set(auth ${match})
     assert_not_empty(${auth})
 
-    matchparam("--command" ${params})
-    set(command ${match})
-    assert_not_empty(${command})
-
     matchparam("--uri" ${params})
     set(uri ${match})
     assert_not_empty(${uri})
@@ -137,16 +133,19 @@
         set(testname "${testname}|alt")
     endif()
 
-    set(testname "${testname}|${command}|${uri}")
+    string(REPLACE " " "" cmdname ${cmd})
+    set(testname "${testname}|${cmdname}|${uri}")
 
     set(arguments ${params})
     separate_arguments(arguments)
-    add_test(${testname} tester ${arguments})
+    add_test(${testname} tester ${arguments} "--command" "${cmd}")
 endfunction(runtest)
 
 function(preadvectest_single params ranges)
-    runtest("${params} --command preadvec ${ranges}")
-    runtest("${params} --command preadvec ${ranges} nomulti")
+    runtest("${params}" "preadvec ${ranges} mergewindow=1")
+    runtest("${params}" "preadvec ${ranges} mergewindow=1000")
+    runtest("${params}" "preadvec ${ranges} nomulti,mergewindow=1000")
+    runtest("${params}" "preadvec ${ranges} nomulti,mergewindow=1")
 endfunction(preadvectest_single)
 
 function(preadvectest params)
@@ -156,25 +155,25 @@
 endfunction(preadvectest)
 
 function(fulltest params)
-    runtest("${params} --command makeCollection")
-    runtest("${params} --command populate 5")
-    runtest("${params} --command listing 5")
+    runtest("${params}" "makeCollection")
+    runtest("${params}" "populate 5")
+    runtest("${params}" "listing 5")
     preadvectest("${params}")
-    runtest("${params} --command movefile")
-    runtest("${params} --command depopulate 3")
-    runtest("${params} --command countfiles 2")
-    runtest("${params} --command remove")
+    runtest("${params}" "movefile")
+    runtest("${params}" "depopulate 3")
+    runtest("${params}" "countfiles 2")
+    runtest("${params}" "remove")
 endfunction(fulltest)
 
 function(s3tests params)
-    runtest("${params} --command makeCollection")
-    runtest("${params} --command populate 5")
-    runtest("${params} --command listing 5")
+    runtest("${params}" "makeCollection")
+    runtest("${params}" "populate 5")
+    runtest("${params}" "listing 5")
     preadvectest("${params}")
-    runtest("${params} --command movefile")
-    runtest("${params} --command depopulate 3")
-    runtest("${params} --command countfiles 2")
-    runtest("${params} --command depopulate 5")
+    runtest("${params}" "movefile")
+    runtest("${params}" "depopulate 3")
+    runtest("${params}" "countfiles 2")
+    runtest("${params}" "depopulate 5")
 endfunction(s3tests)
 
 function(test_with_proxy uri)
@@ -199,11 +198,11 @@
 function(test_azure azurekey uri)
     set(params "--auth azure --azurekey ${azurekey} --uri ${uri}")
 
-    runtest("${params} --command populate 5")
-    runtest("${params} --command statdir")
-    runtest("${params} --command listing 5")
+    runtest("${params}" "populate 5")
+    runtest("${params}" "statdir")
+    runtest("${params}" "listing 5")
     preadvectest("${params}")
-    runtest("${params} --command depopulate 5")
+    runtest("${params}" "depopulate 5")
 endfunction(test_azure)

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -23,8 +23,9 @@
 file(GLOB src_parser xmlparser/*.cpp)
 file(GLOB src_files files/*.cpp)
 file(GLOB src_auth  auth/*.cpp)
+file(GLOB src_parser  parser/*.cpp)
+
 LIST(APPEND src_utils utils/utils_test.cpp ${SRC_STRING_UTILS_CPP})
-LIST(APPEND src_parser parser/parser_test.cpp)
 LIST(APPEND src_httprequest sessionfactory/test_factory.cpp)
 
 
@@ -34,11 +35,6 @@
                 ${SRC_HMACSHA1} ${davix_tool_common_src} ${src_files} ${src_alibxx})
 
 target_link_libraries(g_test_unit_davix_exe alibxx_core libdavix gtest gtest_main ${CMAKE_THREAD_LIBS_INIT} ${LIBSSL_PKG_LIBRARIES} ${Boost_LIBRARIES})
-
-if(HAVE_CLOCK_GETTIME)
-    target_link_libraries(g_test_unit_davix_exe rt)
-endif(HAVE_CLOCK_GETTIME)
-
 add_dependencies(g_test_unit_davix_exe libdavix)

=== debian/changelog ===
davix (0.6.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add OpenSSL 1.1.0 support (Closes: #828279).
  * Don't install gtest's header files or static libs.

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Thu, 15 Dec 2016 21:40:12 +0100

davix (0.6.4-1) unstable; urgency=medium

  * Update to version 0.6.4
  * Change Maintainer e-mail (fysast → physics)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 25 Aug 2016 15:23:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: davix
 Priority: optional
-Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
-Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libboost-system-dev, libboost-thread-dev, libboost-program-options-dev, rapidjson-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python-sphinx
+Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
+Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libboost-system-dev, libboost-thread-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python-sphinx, zlib1g-dev
 Standards-Version: 3.9.8
 Section: net
 Homepage: http://dmc.web.cern.ch/projects/davix/home

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,6 @@
 override_dh_auto_configure:
 	# Remove bundled stuff
 	rm -rf deps/boost_intern
-	rm -rf deps/rapidjson
 	rm -rf deps/strptime
 	rm -rf test/pywebdav
 	# Debian's gtest is not precompiled - link source
@@ -32,6 +31,7 @@
 
 override_dh_install:
 	rm debian/tmp/usr/share/doc/davix/LICENSE
+	rm -rf debian/tmp/usr/include/gtest debian/tmp/usr/lib/libgtest.a debian/tmp/usr/lib/libgtest_main.a
 	dh_install --fail-missing
 
 override_dh_strip:

## davix 0.6.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,8 @@
 include(ReleaseDebugAutoFlags REQUIRED)
 include(CMakeGeneratePkgConfig REQUIRED)
 include(MacroAddDoxygen REQUIRED)
+include(CMakeCXX11Support REQUIRED)
 include(PortabilityGNUCheck REQUIRED)
-include(CMakeCXX11Support REQUIRED)
 
 #enable testing
 INCLUDE(CTest)
@@ -29,14 +29,10 @@
 set(OUTPUT_NAME_DAVIX "davix")
 set(VERSION_MAJOR 0)
 set(VERSION_MINOR 6)
-set(VERSION_PATCH 4)
+set(VERSION_PATCH 6)
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 set(VERSION_TAG "")
 
-
-# dependency mode
-option(BOOST_EXTERNAL "Enable the usage of an external boost dependency" TRUE)
-set (Boost_NO_BOOST_CMAKE ON)
 
 # components
 option(ENABLE_TOOLS "enable or disable tools " TRUE)
@@ -64,10 +60,6 @@
 find_package(LibXml2)
 set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})
 
-if(BOOST_EXTERNAL)
-find_package(Boost 1.41.0 COMPONENTS thread system)
-endif(BOOST_EXTERNAL)
-
 #const
 set(HAVE_OPENSSL 1)
 set(NE_HAVE_SSL 1)
@@ -75,6 +67,8 @@
 add_subdirectory(deps)
 
 
+#libuuid
+find_package(uuid)
 
 
 ## general defs
@@ -85,14 +79,17 @@
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")
 
-include_directories( ${Boost_INCLUDE_DIRS})
 include_directories( ${HTTPLIB_PKG_INCLUDE_DIRS} ${GLIB2_PKG_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/deps ${CMAKE_CURRENT_SOURCE_DIR}/deps/libneon/src/ )
 include_directories( ${CMAKE_SOURCE_DIR}/include/davix )
 include_directories( ${CMAKE_SOURCE_DIR}/src/libs/)
 
 add_subdirectory (src)
 add_subdirectory (doc)
-add_subdirectory (dist)
+
+if(EXISTS "${CMAKE_SOURCE_DIR}/dist/CMakeLists.txt")
+  add_subdirectory (dist)
+endif()
+
 add_subdirectory (test)
 add_subdirectory (packaging)

=== debian/changelog ===
davix (0.6.6-1build1) artful; urgency=medium

  * Rebuild against new libgsoap-2.8.49.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Jul 2017 08:30:26 +0200

davix (0.6.6-1) unstable; urgency=medium

  * Update to version 0.6.6

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 16 May 2017 12:55:22 +0200

davix (0.6.5-1) unstable; urgency=medium

  * Update to version 0.6.5
  * Acknowledge NMU - thanks to Sebastian Andrzej Siewior for backporting
    upstream's openssl 1.1 adaptations
  * Drop the openssl 1.1 patches since they are now in the released version
  * Unbundle python-sphinx-rtd-theme

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 22 Mar 2017 21:50:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: davix
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
-Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libboost-system-dev, libboost-thread-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python-sphinx, zlib1g-dev
+Build-Depends: debhelper (>= 9), cmake, libxml2-dev, libssl-dev, gsoap, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python-sphinx, python-sphinx-rtd-theme, zlib1g-dev, uuid-dev
 Standards-Version: 3.9.8
 Section: net
 Homepage: http://dmc.web.cern.ch/projects/davix/home
@@ -38,7 +38,8 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Pre-Depends: dpkg (>= 1.17.14)
+Depends: ${misc:Depends}, sphinx-rtd-theme-common, libjs-jquery, libjs-underscore
 Description: Documentation for davix
  Documentation and examples for davix. Davix is a toolkit designed for file
  operations with Http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,9 @@
 
 override_dh_auto_configure:
 	# Remove bundled stuff
-	rm -rf deps/boost_intern
 	rm -rf deps/strptime
 	rm -rf test/pywebdav
+	rm -rf doc/sphinx/_themes/sphinx_rtd_theme
 	# Debian's gtest is not precompiled - link source
 	ln -fs /usr/src/gtest deps/googletest/googletest
 	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
@@ -31,7 +31,24 @@
 
 override_dh_install:
 	rm debian/tmp/usr/share/doc/davix/LICENSE
-	rm -rf debian/tmp/usr/include/gtest debian/tmp/usr/lib/libgtest.a debian/tmp/usr/lib/libgtest_main.a
+	rm -rf debian/tmp/usr/include/gtest
+	rm debian/tmp/usr/lib/libgtest.a
+	rm debian/tmp/usr/lib/libgtest_main.a
+	rm -rf debian/tmp/usr/share/doc/davix/html/_static/css
+	ln -s /usr/share/sphinx_rtd_theme/static/css \
+	   debian/tmp/usr/share/doc/davix/html/_static/css
+	rm -rf debian/tmp/usr/share/doc/davix/html/_static/fonts
+	ln -s /usr/share/sphinx_rtd_theme/static/fonts \
+	   debian/tmp/usr/share/doc/davix/html/_static/fonts
+	rm -rf debian/tmp/usr/share/doc/davix/html/_static/js
+	ln -s /usr/share/sphinx_rtd_theme/static/js \
+	   debian/tmp/usr/share/doc/davix/html/_static/js
+	rm debian/tmp/usr/share/doc/davix/html/_static/jquery.js
+	ln -s /usr/share/javascript/jquery/jquery.js \
+	   debian/tmp/usr/share/doc/davix/html/_static/jquery.js
+	rm debian/tmp/usr/share/doc/davix/html/_static/underscore.js
+	ln -s /usr/share/javascript/underscore/underscore.js \
+	   debian/tmp/usr/share/doc/davix/html/_static/underscore.js
 	dh_install --fail-missing
 
 override_dh_strip:
@@ -40,6 +57,7 @@
 
 override_dh_auto_clean:
 	rm -f deps/googletest/googletest
+	rm -f include/davix/features.hpp
 	dh_auto_clean
 
 override_dh_auto_test:
